/*--Rational Environment Menus - Menu Labels */

#include <stdio.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/IntrinsicP.h>
#include <X11/Xos.h>
#include "RMLabelP.h"


/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

/* Private Data */

static void LabelRealize();

static char label_translat[] =
  "<EnterWindow>:RatMenuDropSubs()";

static Dimension defBWidth = 0;

#define offset(field) XtOffset(RatMenuLabelWidget, field)
static XtResource RatMenuLabelResources[] = {
    {XtNforeground, XtCBackground, XtRPixel, sizeof(Pixel),
	offset(label.foreground), XtRString, "White"},
    {XtNbackground, XtCForeground, XtRPixel, sizeof(Pixel),
        offset(core.background_pixel), XtRString, "Black"},
    {XtNborderWidth, XtCBorderWidth, XtRDimension, sizeof(Dimension),
         offset(core.border_width), XtRDimension, (caddr_t)&defBWidth},
};

#undef offset

extern void RatMenuLabelInitialize();

RatMenuLabelClassRec ratMenuLabelClassRec = {
  {
/* core_class fields */	
    /* superclass	  	*/	(WidgetClass) (&labelClassRec),
    /* class_name	  	*/	"RatMenuLabel",
    /* widget_size	  	*/	sizeof(RatMenuLabelRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	RatMenuLabelInitialize,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	LabelRealize,
    /* actions		  	*/	NULL,
    /* num_actions	  	*/	0,
    /* resources	  	*/	RatMenuLabelResources,
    /* num_resources	  	*/	XtNumber(RatMenuLabelResources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure  	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	XtInheritResize,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	label_translat,
    /* query_geometry		*/	NULL,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  { /* Simple fields */
    /* change_sensitive		*/	XtInheritChangeSensitive,
  }
};
WidgetClass ratMenuLabelWidgetClass = (WidgetClass)&ratMenuLabelClassRec;


/*ARGSUSED*/
void RatMenuLabelInitialize(request,new)
Widget	request;
Widget	new;
{
  ((RatMenuLabelWidget)new)->label.gray_GC =
    ((RatMenuLabelWidget)new)->label.normal_GC;
}

static void LabelRealize(widget, value_mask, attributes)
    Widget		 widget;
    Mask		 *value_mask;
    XSetWindowAttributes *attributes;
{
    (*(ratMenuLabelClassRec.core_class.superclass->core_class.realize))
      ( widget, value_mask, attributes );
    XStoreName( XtDisplay(widget), XtWindow(widget), widget->core.name );
    XSetIconName( XtDisplay(widget), XtWindow(widget), widget->core.name );
}

