/*--Rational Environment Menus - Menu Shell */

#include <stdio.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/IntrinsicP.h>
#include <X11/Xos.h>
#include "ratmenu.h"
#include "RMShellP.h"


/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

/* Private Data */

static Cursor  defCursor  = None;
static Boolean defFalse   = FALSE;
static KeySym  defKeyZero = 0;
static int     defZero = 0;
static String  defNullString = NULL;

#define offset(field) XtOffset(RatMenuShellWidget, field)
static XtResource RatMenuShellResources[] = {
    {XtNcursor, XtCCursor, XtRCursor, sizeof(Cursor),
       offset(ratmenu.menu_cursor), XtRCursor, (caddr_t) &defCursor},
    {XtNsubMenu, XtCBoolean, XtRBoolean, sizeof(Boolean),
       offset(ratmenu.submenu), XtRBoolean, (caddr_t) &defFalse},
    {XtNpermanent, XtCPermanent, XtRBoolean, sizeof(Boolean),
       offset(ratmenu.permanent), XtRBoolean, (caddr_t) &defFalse},
    {XtNmapped, XtCBoolean, XtRBoolean, sizeof(Boolean),
       offset(ratmenu.mapped), XtRBoolean, (caddr_t) &defFalse},
    {XtNmenuDepth, XtCInt, XtRInt, sizeof(int),
       offset(ratmenu.menu_depth), XtRInt, (caddr_t)&defZero},
    {XtNcmdPick, XtCCmdPick, XtRKeySym, sizeof(KeySym),
       offset(ratmenu.cmd_pick), XtRKeySym, (caddr_t) &defKeyZero},
    {XtNmenuPick, XtCMenuPick, XtRKeySym, sizeof(KeySym),
       offset(ratmenu.menu_pick), XtRKeySym, (caddr_t) &defKeyZero},
    {"item0", "Item0", XtRString, sizeof(String),
       offset(ratmenu.user.item[0]), XtRString, (caddr_t)&defNullString},
    {"item1", "Item1", XtRString, sizeof(String),
       offset(ratmenu.user.item[1]), XtRString, (caddr_t)&defNullString},
    {"item2", "Item2", XtRString, sizeof(String),
       offset(ratmenu.user.item[2]), XtRString, (caddr_t)&defNullString},
    {"item3", "Item3", XtRString, sizeof(String),
       offset(ratmenu.user.item[3]), XtRString, (caddr_t)&defNullString},
    {"item4", "Item4", XtRString, sizeof(String),
       offset(ratmenu.user.item[4]), XtRString, (caddr_t)&defNullString},
    {"item5", "Item5", XtRString, sizeof(String),
       offset(ratmenu.user.item[5]), XtRString, (caddr_t)&defNullString},
    {"item6", "Item6", XtRString, sizeof(String),
       offset(ratmenu.user.item[6]), XtRString, (caddr_t)&defNullString},
    {"item7", "Item7", XtRString, sizeof(String),
       offset(ratmenu.user.item[7]), XtRString, (caddr_t)&defNullString},
    {"item8", "Item8", XtRString, sizeof(String),
       offset(ratmenu.user.item[8]), XtRString, (caddr_t)&defNullString},
    {"item9", "Item9", XtRString, sizeof(String),
       offset(ratmenu.user.item[9]), XtRString, (caddr_t)&defNullString},
    {"menu0", "Submenu0", XtRString, sizeof(String),
       offset(ratmenu.user.menu[0]), XtRString, (caddr_t)&defNullString},
    {"menu1", "Submenu1", XtRString, sizeof(String),
       offset(ratmenu.user.menu[1]), XtRString, (caddr_t)&defNullString},
    {"menu2", "Submenu2", XtRString, sizeof(String),
       offset(ratmenu.user.menu[2]), XtRString, (caddr_t)&defNullString},
    {"menu3", "Submenu3", XtRString, sizeof(String),
       offset(ratmenu.user.menu[3]), XtRString, (caddr_t)&defNullString},
    {"menu4", "Submenu4", XtRString, sizeof(String),
       offset(ratmenu.user.menu[4]), XtRString, (caddr_t)&defNullString},
    {"menu5", "Submenu5", XtRString, sizeof(String),
       offset(ratmenu.user.menu[5]), XtRString, (caddr_t)&defNullString},
    {"menu6", "Submenu6", XtRString, sizeof(String),
       offset(ratmenu.user.menu[6]), XtRString, (caddr_t)&defNullString},
    {"menu7", "Submenu7", XtRString, sizeof(String),
       offset(ratmenu.user.menu[7]), XtRString, (caddr_t)&defNullString},
    {"menu8", "Submenu8", XtRString, sizeof(String),
       offset(ratmenu.user.menu[8]), XtRString, (caddr_t)&defNullString},
    {"menu9", "Submenu9", XtRString, sizeof(String),
       offset(ratmenu.user.menu[9]), XtRString, (caddr_t)&defNullString},
};

#undef offset

extern void RatMenuShellRealize();

RatMenuShellClassRec ratMenuShellClassRec = {
  {
/* core_class fields */	
#define oursuperclass		(&transientShellClassRec)
    /* superclass	  	*/	(WidgetClass) oursuperclass,
    /* class_name	  	*/	"RatMenuShell",
    /* widget_size	  	*/	sizeof(RatMenuShellRec),
    /* class_initialize   	*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited       	*/	FALSE,
    /* initialize	  	*/	NULL,
    /* initialize_hook		*/	NULL,
    /* realize		  	*/	RatMenuShellRealize,
    /* actions		  	*/	NULL,
    /* num_actions	  	*/	0,
    /* resources	  	*/	RatMenuShellResources,
    /* num_resources	  	*/	XtNumber(RatMenuShellResources),
    /* xrm_class	  	*/	NULLQUARK,
    /* compress_motion	  	*/	TRUE,
    /* compress_exposure  	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest	  	*/	FALSE,
    /* destroy		  	*/	NULL,
    /* resize		  	*/	XtInheritResize,
    /* expose		  	*/	XtInheritExpose,
    /* set_values	  	*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus	 	*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private   	*/	NULL,
    /* tm_table		   	*/	XtInheritTranslations,
    /* query_geometry		*/	NULL,
    /* display_accelerator  */  NULL,
    /* extension	    */  NULL
  },{
    /* geometry_manager		*/	XtInheritGeometryManager,
    /* change_managed     	*/	XtInheritChangeManaged,
    /* insert_child	  	*/	XtInheritInsertChild,
    /* delete_child	  	*/	XtInheritDeleteChild,
    /* extension	    */  NULL
  },{
    /* extension	    */  NULL
  },{
    /* extension	    */  NULL
  },{
    /* extension	    */  NULL
  },{
    /* extension	    */  NULL
  }
};
WidgetClass ratMenuShellWidgetClass = (WidgetClass)&ratMenuShellClassRec;


void RatMenuShellRealize( w, value_mask, attributes )
     Widget	 		 w;
     XtValueMask		*value_mask;
     XSetWindowAttributes	*attributes;
{
  register RatMenuShellWidget	rw    = (RatMenuShellWidget)w;
  register WidgetClass		super = XtSuperclass(w);
	   Boolean     		rlzd  = FALSE;
  
/*--Make sure that we are what we think we are. */

  if (!XtIsSubclass( w, ratMenuShellWidgetClass )) {
    fprintf( stderr, "RatMenuShellRealize: not a RecMenuShellWidger? [%s]\n",
	     XtClass(w)->core_class.class_name );
    exit(1);
  }

/*--We want to set the cursor value as well as whatever else is already set. */

  *value_mask |= CWCursor;
  attributes->cursor = rw->ratmenu.menu_cursor;

/*--Run down the Superclass chain until we find a Realize procedure. */

  for ( ; super != NULL; super = super->core_class.superclass) {
    if (super->core_class.realize != XtInheritRealize) {
      (*super->core_class.realize)( w, value_mask, attributes );
      rlzd = TRUE;
      break;
    }
  }

/*--If we still aren't realized then force it here. */

  if (!rlzd) {
    XtCreateWindow( w, InputOutput, CopyFromParent, *value_mask, attributes );
  }
  XStoreName( XtDisplay(w), XtWindow(w), w->core.name );
  XSetIconName( XtDisplay(w), XtWindow(w), w->core.name );

}
