/*--Rational Environment Menus - Menu SubMenu arrows */

#include <stdio.h>
#include <X11/Xos.h>
#include <ctype.h>
#include <X11/StringDefs.h>
#include <X11/IntrinsicP.h>
#include "RMSubP.h"

/****************************************************************
 *
 * Full class record constant
 *
 ****************************************************************/

/* Private Data */

static void SubRealize();

static char arrow_translat[] =
    "<EnterWindow>:highlight() RatMenuSubup()\n\
     <LeaveWindow>:unhighlight()";

#define offset(field) XtOffset(RatMenuSubWidget, field)
static XtResource resources[] = { 

   {XtNsubMenu, XtCSubMenu, "Widget", sizeof(Widget), 
      offset(ratmenusub.submenu), "Widget", (caddr_t)NULL},
};
#undef offset

  /* ...ClassData must be initialized at compile time.  Must
     initialize all substructures.  (Actually, last two here
     need not be initialized since not used.)
  */
RatMenuSubClassRec ratMenuSubClassRec = {
  {
    (WidgetClass) &RMcommandClassRec,	/* superclass		  */	
    "RatMenuSub",			/* class_name		  */
    sizeof(RatMenuSubRec),		/* size			  */
    NULL,				/* class_initialize	  */
    NULL,				/* class_part_initialize  */
    FALSE,				/* class_inited		  */
    NULL,				/* initialize		  */
    NULL,				/* initialize_hook	  */
    SubRealize,				/* realize		  */
    NULL,				/* actions		  */
    0,					/* num_actions		  */
    resources,				/* resources		  */
    XtNumber(resources),		/* resource_count	  */
    NULLQUARK,				/* xrm_class		  */
    TRUE,				/* compress_motion	  */
    TRUE,				/* compress_exposure	  */
    TRUE,				/* compress_enterleave    */
    FALSE,				/* visible_interest	  */
    NULL,				/* destroy		  */
    XtInheritResize,			/* resize		  */
    XtInheritExpose,			/* expose		  */
    NULL,				/* set_values		  */
    NULL,				/* set_values_hook	  */
    XtInheritSetValuesAlmost,		/* set_values_almost	  */
    NULL,				/* get_values_hook	  */
    NULL,				/* accept_focus		  */
    XtVersion,				/* version		  */
    NULL,				/* callback_private	  */
    arrow_translat,			/* tm_table		  */
    XtInheritQueryGeometry,		/* query_geometry	  */
    XtInheritDisplayAccelerator,	/* display_accelerator	  */
    NULL				/* extension		  */
  },  /* CoreClass fields initialization */
  { /* SimpleClass fields initialization */
    /* change_sensitive		*/	XtInheritChangeSensitive,
  },
  {
    0,                                     /* field not used    */
  },  /* LabelClass fields initialization */
  {
    0,                                     /* field not used    */
  },  /* RMCommandClass fields initialization */
  {
    0,                                     /* field not used    */
  },  /* RatMenuSub fields initialization */
};

  /* for public consumption */
WidgetClass ratMenuSubWidgetClass = (WidgetClass) &ratMenuSubClassRec;

static void SubRealize(widget, value_mask, attributes)
    Widget		 widget;
    Mask		 *value_mask;
    XSetWindowAttributes *attributes;
{
    (*(ratMenuSubClassRec.core_class.superclass->core_class.realize))
      ( widget, value_mask, attributes );
    XStoreName( XtDisplay(widget), XtWindow(widget), widget->core.name );
    XSetIconName( XtDisplay(widget), XtWindow(widget), widget->core.name );
}

