.TH RXI 1 "March 28, 1991" "X Version 11"
.de Ds
.nf
.\\$1D \\$2 \\$1
.ft 1
.ps \\n(PS
.\".if \\n(VS>=40 .vs \\n(VSu
.\".if \\n(VS<=39 .vs \\n(VSp
..
.de De
.ce 0
.if \\n(BD .DF
.nr BD 0
.in \\n(OIu
.if \\n(TM .ls 2
.sp \\n(DDu
.fi
..
.SH NAME
rxi \- Rational X Interface
.SH SYNOPSIS
.B rxi
[-\fItoolkitoption\fP ...] [-option ...]
.SH DESCRIPTION
The \fIrxi\fP program is a terminal emulator for the X Window System.
It provides DEC VT102-compatible terminals for programs that can't
use the window system directly.  If the underlying operating system supports 
terminal resizing capabilities (for example, the SIGWINCH signal in systems 
derived from 4.3bsd), \fIrxi\fP uses the facilities to notify programs 
running in the window whenever it is resized.
.SH OPTIONS
The \fIrxi\fP terminal emulator 
accepts all of the standard X Toolkit command line options along with the 
additional options listed below (if the option begins with a
.RB ` + '
instead of a
.RB ` \- ',
the option is restored to its default value):
.TP 8
.B \-help
This causes \fIrxi\fP to print out a verbose message describing its options.
.TP 8
.B \-132
Normally, the VT102 DECCOLM escape sequence that switches between 80 and
132 column mode is ignored.
This option causes the DECCOLM escape sequence to be recognized, and the
.I rxi
window resizes appropriately.
.TP 8
.B \-ah
This option indicates that 
.I rxi
should always highlight the text cursor and borders.  By default,
.I rxi
displays a hollow text cursor whenever the focus is lost or the 
mouse cursor leaves the window.
.TP 8
.B \+ah
This option indicates that
.I rxi
should do text cursor highlighting.
.TP 8
.B \-ar
This option causes
.I rxi
windows to "auto-raise" (move themselves to the top of the window stack) if
the mouse cursor stays within the window for more than autoRaiseDelay
milliseconds without leaving.  The default delay is 2.0 seconds.  The +ar
option turns this feature off if a system or user has it on by default.
The normal default for this option is "off".
.TP 8
.BI \-b " number"
This option specifies the size of the inner border (the distance between
the outer edge of the characters and the window border) in pixels.  The
default is 2.
.TP 8
.BI \-cb
This option causes cuts to always start on the beginning of a line.  The
default is "false" which means that cuts start wherever the mouse cursor
is when mouse button 1 is clicked.
.TP 8
.BI \+cb
This option turns off the -cb option and causes cuts to begin wherever the
mouse cursor indicates.
.TP 8
.B "\-cc \fIcharacterclassrange\fP:\fIvalue\fP[,...]"
This sets classes indicated by the given ranges for using in selecting by
words.  See the section specifying character classes.
.TP 8
.BI \-cr " color"
This option specifies the color to use for the text cursor.  The default is to
use the same foreground color that is used for text.
.TP 8
.B \-cu
This option indicates that \fIrxi\fP should work around a bug in the
.IR curses (3x)
cursor motion package that causes the
.IR more (1)
program to display lines that are exactly the width of the window and
are followed by a line beginning with a tab to be displayed incorrectly
(the leading tabs are not displayed).
.TP 8
.B \+cu
This option indicates that that \fIrxi\fP should not work around the
.IR curses (3x)
bug mentioned above.
.TP 8
.BI \-e " program \[arguments \.\.\.\]"
This option specifies the program (and its command line arguments) to be
run in the \fIrxi\fP window.  It also sets the window title and icon
name to be the basename of the program being executed if neither \fI-title\fP
nor \fI-name\fP are given on the command line.  \fBThis must be the last 
option on the command line.\fP
.TP 8
.BI \-fb " font"
This option specifies a font to be used when displaying bold text.  
This font must be the same height and width as the normal font.
The default bold font is ``fixed-screen-b-11.''
If the default font cannot be found or if only one of the normal or bold
fonts has been specified (on the command line, in the user's default file, or
in the system's default file), then it is used as both the normal font and
the bold font.
.TP 8
.B \-fn \fIfont\fP
This option specifies the font to be used for displaying normal text.  The
default is ``fixed-screen-r-11.''
.TP 8
.B \-icongeometry geometry
This option specifies the preferred position of the icon window.
It is shorthand for specifying the "\fI*iconGeometry\fP" resource.
.TP 8
.BI \-icontitle " string"
This option specifies the icon name for \fIrxi\fP's windows.
It is shorthand for specifying the "\fI*iconName\fP" resource.
Note that this is not the same as the toolkit option \fB-name\fP (see below).
The default icon name is the application name.
.TP 8
.B \-j
This option indicates that \fIrxi\fP should do jump scrolling.  Normally,
text is scrolled one line at a time; this option allows \fIrxi\fP to move
multiple lines at a time so that it doesn't fall as far behind.  Its use is
strongly recommended since it make \fIrxi\fP much faster when scanning
through large amounts of text.  The VT100 escape sequences for enabling and
disabling smooth scroll as well as the ``Modes'' menu can be used to turn this
feature on or off.
.TP 8
.B \+j
This option indicates that \fIrxi\fP should not do jump scrolling.
.TP 8
.B \-l
This option indicates that \fIrxi\fP should send all terminal output to
a log file as well as to the screen.  This option can be enabled or disabled
using the ``RXI X11'' menu.
.TP 8
.B \+l
This option indicates that \fIrxi\fP should not do logging.
.TP 8
.BI \-lf " filename"
This option specifies the name of the file to which the output log described
above is written.  If \fIfile\fP begins with a pipe symbol (|), the rest of 
the string is assumed to be a command to be used as the endpoint of a pipe.
The default filename is ``\fBRxiLog.\fIXXXXX\fR'' (where \fIXXXXX\fP
is the process id of \fIrxi\fP) and is created in the directory from which
\fIrxi\fP was started (or the user's home directory in the case of a
login window).
.TP 8
.B \-ls
This option indicates that the shell that is started in the \fIrxi\fP window
be a login shell (i.e., the first character of argv[0] is a dash,
indicating to the shell that it should read the user's .login or .profile).
.TP 8
.B \+ls
This option indicates that the shell that is started should not be a login
shell (i.e., it is a normal ``subshell'').
.TP 8
.B \-mb
This option indicates that \fIrxi\fP should ring a margin bell when
the user types near the right end of a line.  This option can be turned on 
and off from the ``Modes'' menu.
.TP 8
.B \+mb
This option indicates that margin bell should not be rung.
.TP 8
.BI \-ms " color"
This option specifies the color to be used for the mouse cursor.  The default
is to use the foreground color.
.TP 8
.BI \-nb " number"
This option specifies the number of characters from the right end of a line
at which the margin bell, if enabled, rings.  The default is 10.
.TP 8
.BI \-rcg "number/name"
This option modifies the response sent when a terminal-recognition query
is received.  A normal VT100 (with advanced-video-option) response is
Escape followed by "[?1;2c".  -rcg modifies this.  The "2" is replaced by
the value (number<<3)+2.  This allows rxi to be recognized both as a VT100
and as a special Rational terminal type.  The default -rcg value is determined
by the expected workstation type when rxi is compiled and is in the 1..99
range.  Use "-rcg 0" to disable this feature and to cause normal VT100
behavior.

If a name is used for this switch, e.g., "-rcg xsun3", then the name must be
the (all lowercase) name of some RXI-based terminal type supported by the
local R1000 computer.  The recognition value being used can be modified
via the ``RXI Recognition'' menu.
.TP 8
.B \-rv
This option indicates that reverse video should be simulated by swapping
the foreground and background colors.
.TP 8
.B \+rv
This option indicates that normal video should be used.
.TP 8
.B \-rw
This option indicates that reverse-wraparound should be allowed.  This allows
the cursor to back up from the leftmost column of one line to the rightmost
column of the previous line.  This is very useful for editing long shell
command lines and is encouraged.  This option can be turned on and off from
the ``Modes'' menu.
.TP 8
.B \+rw
This option indicates that reverse-wraparound should not be allowed.
.TP 8
.B \-s
This option indicates that \fIrxi\fP may scroll asynchronously, meaning that
the screen does not have to be kept completely up to date while scrolling.
This allows \fIrxi\fP to run faster when network latencies are very high
and is typically useful when running across a very large internet or many
gateways.
.TP 8
.B \+s
This option indicates that \fIrxi\fP should scroll synchronously.
.TP 8
.B \-sb
This option indicates that some number of lines that are scrolled off the top 
of the window should be saved and that a scrollbar should be displayed so that
those lines can be viewed.  This option may be turned on and off from the
``Modes'' menu.
.TP 8
.B \+sb
This option indicates that a scrollbar should not be displayed.
.TP 8
.B \-sf
This option indicates that Sun function-key escape codes should be generated
for function keys.
.TP 8
.B \+sf
This option indicates that the standard escape codes should be generated for
function keys.
.TP 8
.B \-si
This option indicates that output to a window should not automatically
reposition the screen to the bottom of the scrolling region.  
This option can be turned on and off from the ``Modes'' menu.
.TP 8
.B \+si
This option indicates that output to a window should cause it to
scroll to the bottom.
.TP 8
.B \-sk
This option indicates that pressing a key while 
using the scrollbar to review previous lines of text should
cause the window to be repositioned automatically in the normal postion at the
bottom of the scroll region.
.TP 8
.B \+sk
This option indicates that pressing a key while using the scrollbar
should not cause the window to be repositioned.
.TP 8
.BI \-sl " number"
This option specifies the number of lines to save that have been scrolled 
off the top of the screen.  The default is 64.
.TP 8
.BI \-tm " string"
This option specifies a series of terminal setting keywords followed by the
characters that should be bound to those functions, similar to the \fIstty\fP
program.  This is ignored when \fB\-L\fP is given since \fIgetty\fP resets
the terminal.  Allowable keywords include: intr, quit, erase, kill, eof,
eol, swtch, start, stop, brk, susp, dsusp, rprnt, flush, weras, and lnext.
Control characters may be specified as ^char (e.g. ^c or ^u) and ^? may be 
used to indicate delete.
.TP 8
.BI \-tn " name"
This option specifies the name of the terminal type to be set in the TERM
environment variable.  This terminal type must exist in the \fItermcap(5)\fP
database and should have \fIli#\fP and \fIco#\fP entries.
.TP 8
.B \-ut
This option indicates that \fIrxi\fP shouldn't write a record into the 
the system log file \fI/etc/utmp\fP.
.TP 8
.B \+ut
This option indicates that \fIrxi\fP should write a record into the system
log file \fI/etc/utmp\fP.
.TP 8
.B \-vb
This option indicates that a visual bell is preferred over an audible one.
Instead of ringing the terminal bell whenever a Control-G is received, the
window  flashes.
.TP 8
.B \+vb
This option indicates that a visual bell should not be used.
.TP8
.B \-version
This option causes \fIrxi\fP to display version information on stdout and
then to exit.  There are three sections of information.  The "Version"
section tells you what Rational version/terminal-type was installed.  The
"Server" section tells you what X server and what version
of the protocol is being used.  The "Resources" section gives you the
values set for some of the more important control resources.
.TP8
.BI \-x11r2
This option tells \fIrxi\fP that the server (-display option) is an X11R2
server.  The +x11r3 option does the same thing.  The +x11r2 and -x11r3 options
tell \firxi\fP that the server is X11R3.  X11R2 servers did not draw text
correctly.  These options allow you to modify \fIrxi's\fP behavior to suit
the server being used.
.TP 8
.B \-C
This option indicates that this window should receive console output.  This
is not supported on all systems.
.TP 8
.B \-S\fIccn\fP
This option specifies the last two letters of the name of a pseudoterminal
to use in slave mode.  This allows \fIrxi\fP to be used as an input and
output channel for an existing program and is sometimes used in specialized
applications.
.PP
The following command line arguments are provided for compatibility with
older versions.  They may not be supported in the next release as the X 
Toolkit provides standard options that accomplish the same task.
.TP 8
.B \-L
This option indicates that \fIrxi\fP was started by \fIinit\fP.  In this
mode, \fIrxi\fP does not try to allocate a new pseudoterminal as \fIinit\fP
has already done so.  In addition, the system program \fIgetty\fP is run 
instead of the user's shell.  \fBThis option has been superceeded by the new
\fIxdm\fP program; furthermore, this option should never be used by users when
starting terminal windows.\fP
.PP
The following standard X Toolkit command line arguments are commonly used 
with \fIrxi\fP:
.TP 8
.B \-bg \fIcolor\fP
This option specifies the color to use for the background of the window.  
The default is ``white.''
.TP 8
.B \-bd \fIcolor\fP
This option specifies the color to use for the border of the window.
The default is ``black.''
.TP 8
.B \-bw \fInumber\fP
This option specifies the width in pixels of the border surrounding the window.
.TP 8
.B \-display \fIdisplay\fP
This option specifies the X server to contact; see \fIX(1)\fP.
.TP 8
.B \-fg \fIcolor\fP
This option specifies the color to use for displaying text.  The default is 
``black''.
.TP 8
.B \-geometry \fIgeometry\fP
This option specifies the preferred size and position of the VT102 window;
see \fIX(1)\fP.
.TP 8
.B \-iconic
This option indicates that \fIrxi\fP should ask the window manager to 
start it as an icon rather than as the normal window.
.TP 8
.B \-name \fIname\fP
This option specifies the application name under which resources are to be
obtained, rather than the default executable filename.
\fIName\fP should not contain ``.'' or ``*'' characters.
The Class name for the program is ``RXI''.
.TP 8
.B \-title \fIstring\fP
This option specifies the window title string, which may be displayed by
window managers if the user so chooses.  The default title is the command
line specified after the \fB-e\fP option, if any, otherwise the application
name.
.TP 8
.B \-xrm \fIresourcestring\fP
This option specifies a resource string to be used.  This is especially
useful for setting resources that do not have separate command line options.
.SH "X DEFAULTS"
The program understands all of the core X Toolkit resource names and
classes as well as:
.TP 8
.B "autoRaise (\fPclass\fB AutoRaise)"
Specifies whether the auto-raise window feature is turned on.  The default
is "off".  See the -ar switch.
.B "autoRaiseDelay (\fPclass\fB AutoRaiseDelay)"
Specifies the delay between the mouse entering the window and the raising
of the \fIrxi\fP window to the top when the autoRaise feature is turned on.
The default value is 2000 milliseconds.
.TP 8
.B "iconGeometry (\fPclass\fB IconGeometry)"
Specifies the preferred size and position of the application when iconified.
It is not necessarily obeyed by all window managers.
.TP 8
.B "termName (\fPclass\fB TermName)"
Specifies the terminal type name to be set in the TERM environment variable.
.TP 8
.B "title (\fPclass\fB Title)"
Specifies a string that may be used by the window manager when displaying
this application.
.TP 8
.B "ttyModes (\fPclass\fB TtyModes)"
Specifies a string containing terminal setting keywords and the characters
to which they may be bound.  This option is ignored when \fB\-L\fP is given 
since 
\fIgetty\fP resets the terminal.  Allowable keywords include: intr, quit, 
erase, kill, eof, eol, swtch, start, stop, brk, susp, dsusp, rprnt, flush, 
weras, and lnext.  Control characters may be specified as ^char (e.g. ^c or ^u)
and ^? may be used to indicate delete.  This is very useful for overriding
the default terminal settings without having to do an \fIstty\fP every time
an \fIrxi\fP is started.
.TP 8
.B "utmpInhibit (\fPclass\fB UtmpInhibit)"
Specifies whether or not \fIrxi\fP should try to record the user's terminal
in \fI/etc/utmp\fP.
.TP 8
.B "sunFunctionKeys (\fPclass\fB SunFunctionKeys)"
Specifies whether or not Sun function-key escape codes should be generated for
function keys instead of standard escape sequences.
.sp
.PP
The following resources are specified as part of the ``vt100'' widget (class
``VT100''):
.TP 8
.B "allowSendEvents (\fPclass\fB AllowSendEvents)"
Specifies whether or not synthetic key and button events (generated using
the X protocol SendEvent request) should be interpreted or discarded.
The default is ``false'', meaning they are discarded.  Note that allowing
such events creates a very large security hole.
.sp
.TP 8
.B "alwaysHighlight (\fPclass\fB AlwaysHighlight)"
Specifies whether or not \fIrxi\fP should always display a highlighted 
text cursor.  By default, a hollow text cursor is displayed whenever the
mouse cursor moves out of the window or the window loses the input focus.
.TP 8
.B "font (\fPclass\fB Font)"
Specifies the name of the normal font.  The default is ``fixed-screen-r-11.''
.TP 8
.B "boldFont (\fPclass\fB Font)"
Specifies the name of the bold font.  The default is ``fixed-screen-b-11.''
.TP 8
.B "c132 (\fPclass\fB C132)"
Specifies whether or not the VT102 DECCOLM escape sequence should be honored.
The default is ``false.''
.TP 8
.B "charClass (\fPclass\fB CharClass)"
Specifies comma-separated lists of character class bindings of the form
\[\fIlow\fP-\]\fIhigh\fP:\fIvalue\fP.  These are used in determining which
sets of characters should be treated the same when doing cut-and-paste.
See the section on specifying character classes.
.TP 8
.B "curses (\fPclass\fB Curses)"
Specifies whether or not the last column bug in
.IR curses (3x)
should be worked around.
The default is ``false.''
.TP 8
.B "background (\fPclass\fB Background)"
Specifies the color to use for the background of the window.  The default is 
``white.''
.TP 8
.B "foreground (\fPclass\fB Foreground)"
Specifies the color to use for displaying text in the window.  Setting the
class name instead of the instance name is an easy way to have everything
that would normally appear in the "text" color change color.  The default
is ``black.''
.TP 8
.B "cursorColor (\fPclass\fB Foreground)"
Specifies the color to use for the text cursor.  The default is ``black.''
.TP 8
.B "geometry (\fPclass\fB Geometry)"
Specifies the preferred size and position of the VT102 window.
.TP 8
.B "internalBorder (\fPclass\fB BorderWidth)"
Specifies the number of pixels between the characters and the window border.
The default is 2.
.TP 8
.B "jumpScroll (\fPclass\fB JumpScroll)"
Specifies whether or not jump scroll should be used.  The default is ``false''.
.TP 8
.B "logFile (\fPclass\fB Logfile)"
Specifies the name of the file to which a terminal session is logged.  The
default is ``\fBRxiLog.\fIXXXXX\fR'' (where \fIXXXXX\fP
is the process id of \fIrxi\fP).
.TP 8
.B "logging (\fPclass\fB Logging)"
Specifies whether or not a terminal session should be logged.  The default is
``false.''
.TP 8
.B "logInhibit (\fPclass\fB LogInhibit)"
Specifies whether or not terminal session logging should be inhibited.  The
default is ``false.''
.TP 8
.B "loginShell (\fPclass\fB LoginShell)"
Specifies whether or not the shell to be run in the window should be started
as a login shell.  The default is ``false.''
.TP 8
.B "marginBell (\fPclass\fB MarginBell)"
Specifies whether or not the bell should be run when the user types near the
right margin.  The default is ``false.''
.TP 8
.B "multiClickTime (\fPclass\fB MultiClickTime)"
Specifies the maximum amount of time to wait for a double-click on a mouse.
The interval is in milliseconds.  The default is 250.  Pauses of longer than
250 milliseconds between clicks of the same mouse button registers as
two separate clicks rather than as one double-click.
.TP 8
.B "multiScroll (\fPclass\fB MultiScroll)"
Specifies whether or not asynchronous scrolling is allowed.  The default is
``false.''
.TP 8
.B "nMarginBell (\fPclass\fB Column)"
Specifies the number of characters from the right margin at which the margin
bell should be run, when enabled.
.TP 8
.B "pointerColor (\fPclass\fB Foreground)"
Specifies the color of the mouse cursor.  The default is ``black.''
.TP 8
.B "pointerShape (\fPclass\fB Cursor)"
Specifies the name of the shape of the mouse cursor.  The default is ``xterm.''
.TP 8
.B "reverseVideo (\fPclass\fB ReverseVideo)"
Specifies whether or not reverse video should be simulated.  The default is
``false.''
.TP 8
.B "reverseWrap (\fPclass\fB ReverseWrap)"
Specifies whether or not reverse-wraparound should be enabled.  The default is
``false.''
.TP 8
.B "saveLines (\fPclass\fB SaveLines)"
Specifies the number of lines to save beyond the top of the screen when a
scrollbar is turned on.  The default is 64.
.TP 8
.B "scrollBar (\fPclass\fB ScrollBar)"
Specifies whether or not the scrollbar should be displayed.  The default is
``false.''
.TP 8
.B "scrollInput (\fPclass\fB ScrollCond)"
Specifies whether or not output to the terminal should automatically cause
the scrollbar to go to the bottom of the scrolling region.  The default is
``true.''
.TP 8
.B "scrollKey (\fPclass\fB ScrollCond)"
Specifies whether or not pressing a key should automatically cause the
scrollbar to go to the bottom of the scrolling region.  The default is
``false.''
.TP 8
.B "signalInhibit (\fPclass\fB SignalInhibit)"
Specifies whether or not the entries in the ``RXI X11'' menu for sending
signals to \fIrxi\fP should be disallowed.  The default is ``false.''
.TP 8
.B "titeInhibit (\fPclass\fB TiteInhibit)"
Specifies whether or not \fIrxi\fP should remove remove \fIti\fP or \fIte\fP
termcap entries (used to switch between alternate screens on startup of many
screen-oriented programs) from the TERMCAP string.
.TP 8
.B "translations (\fPclass\fB Translations)"
Specifies the key and button bindings for menus, selections, ``programmed
strings'', etc.  See \fBKEY/BUTTON BINDINGS\fP below.
.TP 8
.B "visualBell (\fPclass\fB VisualBell)"
Specifies whether or not a visible bell (i.e., flashing) should be used instead
of an audible bell when Control-G is received.  The default is ``false.''
.sp
.PP
The following resources are specified as part of the ``menu'' widget:
.TP 8
.B "horizDragAmount (\fPclass \fB DragAmount)"
In Rational Mode; specifies the number of columns the R1000 image is
scrolled horizontally for each horizDragTrigger pixels of horizontal movement
by the mouse.  e.g., Each time the mouse moves horizDragTrigger pixels to the
left, then the R1000 window scrolls horizDragAmount columns to the left.
.TP 8
.B "horizDragTrigger (\fPclass \fB DragTrigger)"
In Rational Mode; specifies the number of pixels of mouse movement that
correspond to one horizDragAmount of horizontal scrolling on the R1000.
.TP 8
.B "itemBorder (\fPclass\fB ItemBorder)"
Specifies the width of border placed on menu items in the ``Environment'' menu.
The default is 0.
.TP 8
.B "menuBorder (\fPclass\fB MenuBorder)"
Specifies the size in pixels of the border surrounding menus.  The default is
2.  (All menus.)
.TP 8
.B "menuFont (\fPclass\fB Font)"
Specifies the name of the font to use for displaying menu items.  (All menus.)
.TP 8
.B "menuLabels (\fPclass\fB MenuLabels)"
Menus are labelled if "true".  The default is "true".  (All menus.)
.TP 8
.B "menuPad (\fPclass\fB MenuPad)"
Specifies the number of pixels between menu items and the menu border.  The
default is 3.
.TP 8
.B "menuSpace (\fPclass\fB MenuSpace)"
Specifies the number of pixels between menu items.  The default is 3.
(Rational ``Environment'' menu only.)
.TP 8
.B "permanent" (\fPclass\fB Permanent)"
The ``Environment'' menu can be set up as a permanent menu with this option.
It remains mapped on the display and it is subject to window
manager control.  The default is "false".
.TP 8
.B "subBorder (\fPclass\fB SubBorder)"
Specifies the width of border placed on submenu selector ("=>") items in the
``Environment'' menu.  The default is 0.
.TP 8
.B "subDistance (\fPclass\fB SubBorder)"
Specifies the number of pixels placed between submenu labels and submenu
selector ("=>") items in the ``Environment'' menu.  The default is 3.
.TP 8
.B "subSlide (\fPclass\fB SubSlide)"
When "true", causes submenu selectors ("=>") in the ``Environment'' menu to
"slide" to the right border of the menu; subDistance is ignored in this case.
The default is "false".
.TP 8
.B "submenuLabels (\fPclass\fB SubmenuLabels)"
Submenus are labelled if "true".  The default is "true".  (``Environment'' menu
only.)
.TP 8
.B "vertDragAmount (\fPclass \fB DragAmount)"
In Rational Mode; specifies the number of columns the R1000 image is
scrolled vertically for each vertDragTrigger pixels of vertical movement
by the mouse.  e.g., Each time the mouse moves vertDragTrigger pixels to the
left, then the R1000 window scrolls vertDragAmount columns to the left.
.TP 8
.B "vertDragTrigger (\fPclass \fB DragTrigger)"
In Rational Mode; specifies the number of pixels of mouse movement that
correspond to one vertDragAmount of vertical scrolling on the R1000.
.TP 8
.B "vt100Recognition" (\fPclass \fB Vt100Recognition)"
Defaults to "false".  When "true", forces rxi to act just like a VT100
(actually a VT102).  When "false", it allows rxi to perform
terminal-recognition in the fashion expected by an R1000 computer.  See the
discussion on the -rcg switch and the VT100 Recognition menu entry.
.TP 8
.B "warp (\fPclass\fB Warp)"
When a menu is popped up in response to a button push, then
normally the cursor is "warped" so that it appears over the menu.  This
option prevents that behavior.  The menus pop up normally but the
cursor is not repositioned.  The default is "true".
.sp
.PP
The following resources are specified as part of the ``env'' widget.  The env
widget corresponds to the ``Environment'' menu.  The Environment menu has 10
user-definable slots.  Each slot may be empty (the default), may be a user
selectable item, may be a non-selectable user submenu, or may be a selectable
user submenu.
.TP 8
.B "item0..9 (\fPclass\fB Item0..9)"
The resources RXI*env.item0..item9 are used to provide labels for selectable
user menu items.  A selectable item has a "*" when it appears in the menu.
When a selectable user item is picked from a menu, it transmits
Menu_Pick.'0' if it is item0, Menu_Pick.'1' if item1, etc.  When a selectable
user submenu is picked from a menu, it transmits Menu_Pick followed by
the character specified by the corresponding menu0..9 resource.
User submenus placed within the Environment menu also have user item0..9
resources; these are specified by RXI*env.menu0.item0..9.
.TP 8
.B "menu0..9 (\fPclass\fB Menu0..9)"
The resources RXI*env.menu0..menu9 are used for two purposes.  They provide
labels for non-selectable user submenus or they provide a KeySym for selectable
user submenus.  A selectable submenu has a "*" when it appears in its parent
menu.  When a selectable user submenu is picked from a menu, it transmits
Menu_Pick.KeySym; the KeySym to transmit is determined by the value of the
RXI*env.menu0..9 resource.
User submenus placed within the Environment menu also have user menu0..9
resources; these are specified by RXI*env.menu0.menu0..9.  There can be up
to 4 levels of user submenus; e.g., RXI*env.menu4.menu6.menu0.menu2.item5.
See the app-defaults/RXI file for examples; this file is often in
/usr/lib/X11/app-defaults but your system may use a different directory
structure.
.sp
.PP
The following resources are useful when specified for the Athena Scrollbar
widget:
.TP 8
.B "thickness (\fPclass\fB Thickness)"
Specifies the width in pixels of the scrollbar.
.TP 8
.B "background (\fPclass\fB Background)"
Specifies the color to use for the background of the scrollbar.
.TP 8
.B "foreground (\fPclass\fB Foreground)"
Specifies the color to use for the foreground of the scrollbar.  The ``thumb''
of the scrollbar is a simple checkerboard pattern alternating pixels for
foreground and background color.
.SH EMULATIONS
The VT102 emulation is fairly complete but does not support the blinking
character attribute or the double-wide and double-size character sets.
.IR termcap (5)
entries that work with
.I rxi
include ``xterm'', ``vt102'', ``vt100'' and ``ansi'', and
.I rxi
automatically searches the termcap file in this order for these entries and then
sets the ``TERM'' and the ``TERMCAP'' environment variables.
.PP
Many of the special
.I rxi
features (like logging) may be modified under program control
through a set of escape sequences different from the standard VT102 escape
sequences.  
(See any VT102 manual.)
.SH "MOUSE/POINTER USAGE"
.PP
Once the VT102 window is created,
.I rxi
allows you to select text and copy it within the same or other windows.
.PP
The selection functions are invoked when the mouse buttons are used with no
modifiers and when they are used with the Shift key.
The assignment of the functions described below to keys and buttons may
be changed through the resource database; see \fBKEY/BUTTON BINDINGS\fP below.
.PP
Mouse button 1 (usually left) is used to save text into the cut buffer.
Move the cursor to beginning of the text
and then hold the button down while moving the cursor to the end of the region
and releasing the button.
The selected text is highlighted and is saved in the global cut buffer
and made the PRIMARY selection when
the button is released.  Double-clicking selects by words.  Triple-clicking
selects by lines.  Quadruple-clicking goes back to characters, etc.
Multiple-click is determined by the time from button up to
button down, so you can change the selection unit in the middle of a selection.
If the key/button bindings specify that an X selection is to be made,
\fIrxi\fP leaves the selected text highlighted for as long as it
is the selection owner.
.PP
Mouse button 2 (usually middle) `types' (pastes) the text from
the PRIMARY selection, if any, otherwise from
the cut buffer,
inserting it as keyboard input.
.PP
Mouse button 3 (usually right) extends the current selection
(without loss of generality,
that is you can swap ``right'' and ``left'' everywhere in the rest of this
paragraph...).  If pressed while closer to
the right edge of the selection than the left, it extends/contracts the
right edge of the selection.  If you contract the selection past
the left edge of the selection,
.I rxi
assumes you really meant the left edge, restores the original selection, then
extends/contracts the left edge of the selection.  Extension starts in the 
selection unit mode
that the last selection or extension was performed in; you can multiple-click
to cycle through them.
.PP
By cutting and pasting pieces of text without trailing new lines,
you can take text from several places in different windows and form a command
to the shell, for example, or take output from a program and insert it into
your favorite editor.
Since the cut buffer is globally shared among different applications,
you should regard it as a `file' whose contents you know.
The terminal emulator and other text programs should be treating it as if it
were a text file, i.e., the text is delimited by new lines.
.PP
Special note to Rational users: When connected to a Rational computer the
cut-and-paste buttons work a little differently than described above.
Mouse buttons 1, 2, and 3 transmit the MOUSE_BUTTON1/2/3 key codes to the
Rational.  When the Shift key is pressed; mouse buttons 1, 2, and 3 transmit
the MOUSE_BUTTON4/5/6 key codes to the Rational.
Cut-and-paste operations are performed by simultaneously pressing the Control
and the Shift keys and then using the mouse buttons as described above.
.I Rxi
always allows cut-and-paste using Control-Shift-mice and it follows the
.I xterm cut-and-paste mouse conventions when in non-Rational mode.
.PP
The scroll region displays the position and amount of text currently showing
in the window (highlighted) relative to the amount of text actually saved.
As more text is saved (up to the maximum), the size of the highlighted area
decreases.  
.PP
Clicking button 1 with the mouse cursor in the scroll region moves the
adjacent line to the top of the display window.
.PP
Clicking button 3 moves the top line of the display window down to the
mouse cursor position.
.PP
Clicking button 2 moves the display to a position in the saved text
that corresponds to the mouse cursor's position in the scrollbar.
.SH MENUS
.PP
.I RXI
has four different menus, named
.BR RXI
.BR X11 ,
.BR Modes ,
.BR RXI
.BR Recognition ,
,and
.BR Environment.
Each menu pops up under the correct combinations of key and button presses.
Most menus are divided into two sections, separated by a horizontal line.
The top portion contains various modes that can be altered.
A checkmark appears next to a mode that is currently active.
Selecting one of these modes toggles its state.
The bottom portion of the menu are command entries; selecting one of these
performs the indicated function.
.PP
The
.B RXI X11
menu pops up when the Control key and mouse button 1 are
pressed in a window.
The modes section contains items that apply to the VT102
window.
Notable entries in the command section of the menu are the
.BR Continue ,
.BR Suspend ,
.BR Interrupt ,
.BR Hangup ,
.B Terminate
and
.B Kill
which sends the SIGCONT, SIGTSTP, SIGINT, SIGHUP, SIGTERM and
SIGKILL signals, respectively, to the process group of the process running
under
.I rxi
(usually the shell).
The
.B Continue
function is especially useful if the user has accidentally typed CTRL-Z,
suspending the process.
.PP
The
.B Modes
menu sets various modes in the VT102 emulation; and is popped up when the
Control key and mouse button 2 are pressed in the VT102 window.
In the command section of this menu, the soft reset entry resets
scroll regions.
This can be convenient when some program has left the scroll regions
set incorrectly (often a problem when using VMS or TOPS-20).
The full reset entry clears the screen, resets tabs to every
eight columns, and resets the terminal modes (such as wrap and smooth scroll)
to their initial states just after
.I rxi
has finished processing the command line options.

The menu entry ``X11R2 Text Drawing'' is for use when a)
.I rxi
has been compiled for an X11R2 system but is currently displaying text on an
X11R3 server or, b) when
.I rxi
has been compiled for an X11R3 system but is currently displaying text on an
X11R2 server.  Release 2 and Release 3 of X Windows are not quite compatible
due to a bug in Release 2 pertaining to text.  If you are getting "ghost"
images of your cursor or if certain letters leave little bits of themselves at
the bottom of a scrolled text region, then try toggling the X11R2 Text Drawing
switch.  This probably corrects the problem.

One of the last entries on this menu is one for ``Rational Mode''.  This is
a special mode used when communicating with Rational computers.  Each key on
the keyboard transmits a unique three-character (or sometimes
four-character) sequence when this mode is in use.  Normally the host
computer turns this mode on or off.  However the menu entry is available
both as a flag indicating the current state of the emulation and as a means
of toggling the state.  A Full reset turns ``Rational Mode'' off.

The menu entry ``Permanent Environment Menu'' is RXI/R1000-specific.
This entry tells the ``rxi'' program that whenever ``Rational Mode''
is 'on' that the ``Rational Mode'' menu should be mapped and visible on the
screen (it is a normal window and it might be obscured by other windows on the
screen but the toggling of ``Rational Mode'' either by the user or by the host
computer on the other end of a communications channel brings the menu
forward).

The menu entry ``VT100 Recognition'' is RXI/R1000-specific.  This entry tells
the ``rxi'' program whether or not to act just like a VT100 when a host program
sends a what-are-you query.  A normal VT100 responds to such a query with
the string "\e[?1;nc" (the 'n' is a digit in the 0..7 range; VT102's respond
with 'n'='2' indicating the Advanced Video Option).  Rxi normally responds with
an 'n' that is determined by the value given to the -rcg switch.  For "-rcg 1"
rxi responds with 'n' = (rcg*8)+2 = '10' => "\e[?1;10c". (Different host
workstations have differing default -rcg values; see the RXI documentation for
a list of the values or look at rcg.h in the rxi source area.)  When
this menu item is "on" then normal VT100 recognition is forced to occur; rxi
responds to a what-are-you query with "\e[?1;2c", indicating that it is
VT102-compatible.  Turning this menu item "off" restores normal rxi
operation.  Note: If you log into an R1000 when this menu item is "on", you
are logged in as a VT100.  Type <Escape>.'O'.'n' to get a command window; enter
the QUIT command; then type <Escape>.'O'.'M' to execute the QUIT command and to
logoff the R1000.
.PP
The
.B RXI Recognition
menu pops up when the Control key and mouse button 3 are
pressed in a window.
The recognition section contains all of the different predefined R1000 terminal
types that can be auto-recognized by a fully configured R1000.
The item in this menu with a checkmark indicates the current recognition
are setting; this is the type of terminal that an R1000 would "recognize" upon
login.  Note that giving the -rcg switch an "unknown" (to an R1000) value
when RXI is started results in none of the items in the menu being
checkmarked.
.PP
The
.B Environment
menu is available only when in ``Rational'' mode and is popped up when the
Control key and mouse button 3 are pressed in the VT102 window.
Selection of an entry in this menu is equivalent to a special keystroke using
a fake ``key'' called MENU_PICK in the Rational keymap.
.SH SECURITY
.PP
X environments differ in their security consiousness.  The servers provided
by MIT use a host-based mechanism to control access to the server (see
\fIxhost(1)\fP).  If you enable access for a host, and other users are
also permitted to run clients on that host, there is the possibility that
someone runs an application that attempts to use the basic services
of the X protocol to snoop on your activities and potentially capture a
transcript of everything you type at the keyboard.  This is of particular
concern when you want to type in a password or other sensitive data.
The best solution to this problem is for the industry to choose a standard
authorization mechanism, with the necessary operating system support,
and to incorporate this into the X protocol (which is already designed to
handle such a mechanism).  In the meantime, since passwords are most
commonly typed to something running in an \fIrxi\fP window, a simple
mechanism exists for protecting keyboard input in \fIrxi\fP.
.PP
The \fBRXI X11\fP menu (see \fBMENUS\fP above) contains a \fBSecure Keyboard\fP
entry which, when enabled, ensures that all keyboard input is directed
\fIonly\fP to \fIrxi\fP (using the GrabKeyboard protocol request).
When an application prompts you for a password
(or other sensitive data), you can enable \fBSecure Keyboard\fP using the
menu, type in the data, and then disable \fBSecure Keyboard\fP using
the menu again.  Only one X client at a time can secure the keyboard,
so when you attempt to enable \fBSecure Keyboard\fP it may fail.  In
this case, the bell sounds.  If the \fBSecure Keyboard\fP succeeds,
the foreground and background colors are exchanged (as if you
selected the \fBReverse Video\fP entry in the \fBModes\fP menu);
they are exchanged again when you exit secure mode.  If the colors
do \fInot\fP switch, then
you should be \fIvery\fP suspicious that you are being spoofed.  If
the application you are running displays a prompt before asking for
the password, it is safest to enter secure mode \fIbefore\fP the
prompt gets displayed, and to make sure that the prompt gets displayed
correctly (in the new colors), to minimize the probability of
spoofing.  You can also bring up the menu again and make sure that a checkmark
appears next to the entry.
.PP
\fBSecure Keyboard\fP mode is disabled automatically if your rxi
window becomes iconified (or otherwise unmapped) or if you start up
a reparenting window manager (that places a title bar or other decoration
around the window) while in \fBSecure Keyboard\fP mode.  (This is a
feature of the X protocol not easily overcome.)  When this happens,
the foreground and background colors switch back and the bell
sounds in warning.
.SH "CHARACTER CLASSES"
Clicking the middle mouse button twice in rapid succession causes all
characters of the same class (e.g. letters, white space, punctuation) to be
selected.  Since different people have different preferences for what should
be selected (for example, should filenames be selected as a whole or only
the separate subnames), the default mapping can be overridden through the use 
of the \fIcharClass\fP (class \fICharClass\fP) resource.
.PP
This resource is simply a list of \fIrange\fP:\fIvalue\fP pairs where the
range is either a single number or \fIlow\fP-\fIhigh\fP in the range of 0
to 127, corresponding to the ASCII code for the character or characters to be
set.  The \fIvalue\fP is arbitrary, although the default table uses the
character number of the first character occurring in the set.
.PP
The default table is:
.sp
.in +10
.nf
static int charClass[128] = {
/* NUL  SOH  STX  ETX  EOT  ENQ  ACK  BEL */
    32,   1,   1,   1,   1,   1,   1,   1,
/*  BS   HT   NL   VT   NP   CR   SO   SI */
     1,  32,   1,   1,   1,   1,   1,   1,
/* DLE  DC1  DC2  DC3  DC4  NAK  SYN  ETB */
     1,   1,   1,   1,   1,   1,   1,   1,
/* CAN   EM  SUB  ESC   FS   GS   RS   US */
     1,   1,   1,   1,   1,   1,   1,   1,
/*  SP    !    "    #    $    %    &    ' */
    32,  33,  34,  35,  36,  37,  38,  39,
/*   (    )    *    +    ,    -    .    / */
    40,  41,  42,  43,  44,  45,  46,  47,
/*   0    1    2    3    4    5    6    7 */
    48,  48,  48,  48,  48,  48,  48,  48,
/*   8    9    :    ;    <    =    >    ? */
    48,  48,  58,  59,  60,  61,  62,  63,
/*   @    A    B    C    D    E    F    G */
    64,  48,  48,  48,  48,  48,  48,  48,
/*   H    I    J    K    L    M    N    O */
    48,  48,  48,  48,  48,  48,  48,  48,
/*   P    Q    R    S    T    U    V    W */ 
    48,  48,  48,  48,  48,  48,  48,  48,
/*   X    Y    Z    [    \\    ]    ^    _ */
    48,  48,  48,  91,  92,  93,  94,  48,
/*   `    a    b    c    d    e    f    g */
    96,  48,  48,  48,  48,  48,  48,  48,
/*   h    i    j    k    l    m    n    o */
    48,  48,  48,  48,  48,  48,  48,  48,
/*   p    q    r    s    t    u    v    w */
    48,  48,  48,  48,  48,  48,  48,  48,
/*   x    y    z    {    |    }    ~  DEL */
    48,  48,  48, 123, 124, 125, 126,   1};
.fi
.sp
.in -10
For example, the string ``33:48,37:48,45-47:48,64:48'' indicates that the
exclamation mark, percent sign, dash, period, slash, and ampersand characters
should be treated the same way as characters and numbers.  This is very useful 
for cutting and pasting electronic mailing addresses and UNIX filenames.
.SH "KEY TRANSLATIONS"
.PP
It is possible to rebind keys (or sequences of keys) to arbitrary strings
for input by changing the translations for the vt100 widget.
Changing the translations for events other than key and button events
is not expected and causes unpredictable behavior.
.PP
The actions available for key translations are:
.TP 15
.B insert()
Processes the key in the normal way; i.e., inserts the
ASCII character code corresponding to the keysym found in the
keyboard mapping table into the input stream.
.TP 15
.B string(\fIstring\fB)
Rebinds the key or key sequence to the string value; that is, inserts the
string argument into the input stream.
Quotation is necessary if the string contains whitespace or
non-alphanumeric characters.  If the string argument begins with the
characters ``0x'', it is interpreted
as a hex character constant and the corresponding character is sent
in the normal way.
.TP 15
.B keymap(\fIname\fB)
The \fBkeymap\fP action takes a single string argument naming a resource
to be used to dynamically define a new translation table; the name of the
resource is obtained by appending the string ``Keymap'' to
\fIname\fP.   The keymap name \fBNone\fP
restores the original translation table
(the very first one; a stack is not maintained).  Upper/lowercase is
significant.
.TP 15
.B insert-selection(\fIname\fP[,\fIname\fP]...\fB)
Retrieves the value of the first (leftmost) named selection that exists
or cut buffer that is non-empty
and inserts the value into the input stream. \fIName\fP is the
name of any selection (for example, \fBPRIMARY\fP or \fBSECONDARY\fP), or
the name of a cut buffer: \fBCUT_BUFFER0\fP, ..., \fBCUT_BUFFER7\fP.
Upper/lowercase is significant.
.PP
For example, a debugging session might benefit from the following bindings:
.sp
.in +4
.Ds
.TA .5i
.ta .5i
*VT100.Translations: #override <Key>F13: keymap(dbx)
*VT100.dbxKeymap.translations: \\
	<Key>F14: keymap(None) \\n\\
	<Key>F17: string("next") string(0x0d) \\n\\
	<Key>F18: string("step") string(0x0d) \\n\\
	<Key>F19: string("continue") string(0x0d) \\n\\
	<Key>F20: string("print ") insert-selection(PRIMARY, CUT_BUFFER0)
.De
.sp
.in -4
.SH KEY/BUTTON BINDINGS
Within the VT100 widget the key and button bindings for selecting
text, pasting text, and activating the menus are controlled by the
translation bindings.  In addition to the actions listed above under
\fBKEY TRANSLATIONS\fP, the following actions are available:
.TP 15
.B mode-menu()
Posts one of the two mode menus, depending on which button is pressed.
.TP 15
.B select-start()
Unselects any previously selected text and begins selecting new text.
.TP 15
.B select-extend()
Continues selecting text from the previous starting position.
.TP 15
.B start-extend()
Begins extending the selection from the farthest (left or right) edge.
.TP 15
.B select-end(\fIname\fP[,\fIname\fP]...\fB)
Ends the text selection.  \fIName\fP is the name of a selection or
the name of a cut buffer into which the text is to be copied.  \fIrxi\fP
asserts ownership of all the selections named and copies the text
into each of the cut buffers.  Upper/lowercase is significant.
.TP 15
.B ignore()
Quietly discards the key or button event.
.TP 15
.B bell(\fP[\fIvolume\fP]\fB)
Rings the bell at the specified volume increment above/below the base volume.
.PP
The default bindings are:
.sp
.in +4
.Ds
.TA .5i 1i 2i
.ta .5i 1i 2i
		<KeyPress>:	insert() \\n\\
 Ctrl	~Meta	<Btn1Down>:	mode-menu() \\n\\
	~Meta	<Btn1Down>:	select-start() \\n\\
	~Meta	<Btn1Motion>:	select-extend() \\n\\
 Ctrl	~Meta	<Btn2Down>:	mode-menu() \\n\\
~Ctrl	~Meta	<Btn2Down>:	ignore() \\n\\
	~Meta	<Btn2Up>:	insert-selection(PRIMARY, CUT_BUFFER0) \\n\\
~Ctrl	~Meta	<Btn3Down>:	start-extend() \\n\\
	~Meta	<Btn3Motion>:	select-extend() \\n\\
	~Meta	<BtnUp>:	select-end(PRIMARY, CUT_BUFFER0) \\n\\
		<BtnDown>:	bell(0)
.De
.sp
.in -4
.SH "STARTING RXI FROM INIT"
.PP
\fBWarning, this feature is now obsolete and may not be supported in 
future releases.  Sites using this method should switch to \fIxdm\fP 
instead.\fR
.PP
On operating systems such as 4.3bsd and Ultrix, the server and initial login 
window are normally started automatically by 
\fIinit(8)\fP.
.PP
By convention, the pseudoterminal with the
highest minor device number (e.g. \fI\/dev\/ttyqf\fP and \fI\/dev\/ptyqf\fP)
is renamed for
the lowest display number (e.g. \fI\/dev\/ttyv0\fP and \fI\/dev\/ptyv0\fP).
Machines that have more than one
display can repeat this process using \fIttyqe\fP for \fIttyv1\fP, and 
so on.
.PP
Once the pseudoterminals are in place, a line similar to the following may be 
added to \fI/etc/ttys\fP (replacing \fIXqvss\fP with the appropriate server
and putting it all on one line):
.sp
.in +4
.nf
ttyv0 "/usr/bin/X11/rxi -L -geom 80x24+1+1 -display :0" 
	rxi on secure window="/usr/bin/X11/Xqvss :0"
.fi
.in -4
.PP
Sites that used to run X10 should note that the colon in the server display
number is required.
.PP
Although the release installs both the X server and 
\fIrxi\fP in /usr/bin/X11 by default, many sites choose to make a copy of
both of these programs on the root partition (usually in /etc) so that they
may still be used even if the partition containing /usr/bin/X11 isn't mounted.
.PP
Some versions of \fIinit\fP have relatively small program name buffer 
sizes and treat all sharp signs as comment delimiters.  Sites that wish to
list large numbers of options on the rxi line needs to write a small
shell script to exec the long rxi line.  The best solution, of course, is
to use \fIxdm\fP.
.PP
The
.B Environment
menu is available only when in ``Rational'' mode and is popped up when the
Control key and mouse button 3 are pressed in the VT102 window.
Selection of an entry in this menu is equivlent to a special keystroke using
a fake ``key'' called MENU_PICK in the Rational keymap.
.SH "OTHER FEATURES"
.I RXI
automatically highlights the window border and text cursor when the
mouse cursor enters the window (selected) and unhighlights them when the
cursor leaves the window (unselected).
If the window is the focus window, then the window is highlighted no matter
where the mouse cursor goes.
.PP
There are escape sequences to activate and deactivate
an alternate screen buffer, which is the same size as the display area
of the window.
When activated, the current screen is saved and replace with the alternate
screen.
Saving of lines scrolled off the top of the window is disabled until the
normal screen is restored.
The
.IR termcap (5)
entry for
.I rxi
allows the visual editor
.IR vi (1)
to switch to the alternate screen for editing and restore the screen
on exit.  
.PP
There are escape sequences to change the
name of the windows and to specify a new log filename.
.SH ENVIRONMENT
.I RXI
sets the environment variables ``TERM'' and ``TERMCAP'' properly for the
size window you have created.
It also uses and sets the environment
variable ``DISPLAY'' to specify which bit map display terminal to use.
The environment variable ``WINDOWID'' is set to the X window id number
of the
.I rxi
window.
.SH "SEE ALSO"
resize(1), X(1), pty(4), tty(4)
.SH BUGS
.PP
The \fB\-L\fP option is no longer needed as the new \fIxdm\fP display manager
system handles logging in in a much cleaner way.  No more messing around with
trying to match colors in \fI/etc/ttys\fP or worrying about an unwanted login
window.  \fBThis option may be removed in future releases.\fP
.PP
\fBRxi hangs forever if you try to paste too much text at one time.\fP
It is both producer and consumer for the pty and can deadlock.
.PP
Variable-width fonts are not handled reasonably.
.PP
This program still needs to be rewritten.  It should be split into very
modular sections, with the various emulators being completely separate
widgets that don't know about each other.  Ideally, you'd like to be able to
pick and choose emulator widgets and stick them into a single control widget.
.PP
The focus is considered lost if some other client (e.g., the window manager)
grabs the pointer; it is difficult to do better without an addition to the
protocol.
.PP
There needs to be a dialog box to allow entry of log filename
and the COPY filename.
.PP
Many of the options are not resettable after
.I rxi
starts.
.PP
This manual page is too long.  There should be a separate users manual
defining all of the non-standard escape sequences.
.PP
All programs should be written to use X directly; then we could
eliminate this program.
.SH COPYRIGHT
Copyright 1988, Massachusetts Institute of Technology.
.br
Copyright 1988, 1989, Rational.
.br
See \fIX(1)\fP for a full statement of rights and permissions.
.SH VERSION
.nf
March 28, 1991
!Machine.Release.X_Interface.Release10_9_0.
XSun3 80x80
.fi
.SH AUTHORS
Far too many people, including:
.sp
Loretta Guarino Reid (DEC-UEG-WSL), 
Joel McCormack (DEC-UEG-WSL), Terry Weissman (DEC-UEG-WSL),
Edward Moy (Berkeley), Ralph R. Swick (MIT-Athena),
Mark Vandevoorde (MIT-Athena), Bob McNamara (DEC-MAD),
Jim Gettys (MIT-Athena), Bob Scheifler (MIT X Consortium), Doug Mink (SAO),
Steve Pitschke (Stellar), Ron Newman (MIT-Athena), Jim Fulton (MIT X 
Consortium), Dave Serisky (HP)
